function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useMemo, useContext } from 'react';
import TabProduct from "../../../tabProduct";
import Search from "../../components/Search";
import { formatProductListByCategory } from "../utils";
import { Context } from "../../model";
import EmptyCom from "../../../booking/components/emptyBooking";
import ProductItem from "./ProductItem";
import { Skeleton } from 'antd';
import "./index.less";
import { locales } from '@pisell/utils';
var ProductList = function ProductList(_ref) {
  var loading = _ref.loading,
    list = _ref.list;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    search = _useState2[0],
    setSearch = _useState2[1];
  var _useContext = useContext(Context),
    state = _useContext.state,
    dispatch = _useContext.dispatch;
  var products = state.products,
    currentSelectDayDetail = state.currentSelectDayDetail;

  // 过滤和格式化商品数据
  var renderList = useMemo(function () {
    var isIncludes = function isIncludes(str) {
      return str.toLowerCase().indexOf(search.toLowerCase()) !== -1;
    };

    // 当天的不需要二级分类,直接展示
    if (currentSelectDayDetail) {
      return list.filter(function (item) {
        return isIncludes(item.title);
      });
    }
    return formatProductListByCategory(list, search ? function (item) {
      return isIncludes(item.title);
    } : undefined);
  }, [search, list, currentSelectDayDetail]);
  console.log('state.scheduleMap', renderList);
  var searchChange = function searchChange(e) {
    setSearch(e);
  };
  var onClickItem = function onClickItem(item) {
    var newData = {
      products: _objectSpread(_objectSpread({}, products), {}, {
        currentProduct: item,
        openProductDetailDrawer: !currentSelectDayDetail
      })
    };
    if (currentSelectDayDetail) {
      newData = {
        tabKey: 'schedules',
        products: _objectSpread(_objectSpread({}, products), {}, {
          currentProduct: item,
          openProductDetailDrawer: !currentSelectDayDetail
        })
      };
    }
    dispatch({
      type: 'setState',
      payload: newData
    });
  };
  var empty = useMemo(function () {
    return /*#__PURE__*/React.createElement(EmptyCom, {
      description: locales.getText('pisell2.text.products.no-products')
    });
  }, []);
  var listDom = useMemo(function () {
    if (currentSelectDayDetail) {
      return /*#__PURE__*/React.createElement("div", {
        className: "pisell-lowcode__schedules-component-products-list-day"
      }, renderList.map(function (item) {
        return /*#__PURE__*/React.createElement(ProductItem, {
          key: item.id,
          item: item,
          onClickItem: onClickItem,
          layout: "day"
        });
      }));
    }
    return /*#__PURE__*/React.createElement(TabProduct, {
      scrollDom: ".pisell-lowcode__schedules-component-products",
      list: renderList,
      renderItem: function renderItem(item) {
        return /*#__PURE__*/React.createElement(ProductItem, {
          key: item.id,
          item: item,
          onClickItem: onClickItem
        });
      }
    });
  }, [currentSelectDayDetail, renderList, onClickItem]);
  return /*#__PURE__*/React.createElement(Skeleton, {
    className: "pisell-lowcode__schedules-component-products-list-wrap",
    round: true,
    active: true,
    loading: loading
  }, !list.length ? empty : /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Search, {
    value: search,
    onChange: searchChange,
    style: {
      marginTop: 16
    }
  }), renderList.length ? listDom : empty));
};
export default ProductList;